diff -Naupr transgui-5.18.0/passwcon.pas transgui/passwcon.pas
--- transgui-5.18.0/passwcon.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/passwcon.pas	2024-11-20 23:40:05.884955303 +0700
@@ -1,3 +1,33 @@
+{*************************************************************************************
+  This file is part of Transmission Remote GUI.
+  Copyright (c) 2008-2019 by Yury Sidorov and Transmission Remote GUI working group.
+
+  Transmission Remote GUI is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  Transmission Remote GUI is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with Transmission Remote GUI; if not, write to the Free Software
+  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 unit passwcon;
 
 {$mode objfpc}{$H+}
diff -Naupr transgui-5.18.0/restranslator.pas transgui/restranslator.pas
--- transgui-5.18.0/restranslator.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/restranslator.pas	2024-11-20 23:40:05.884955303 +0700
@@ -1,9 +1,34 @@
-{************************************************************
+{*************************************************************************************
+  This file is part of Transmission Remote GUI.
+  Copyright (c) 2011-2013 by Yury Sidorov
   Copyright (c) 2010 Alex Cherednichenko, aka Alex7Che.
-  Copyright (c) 2011-2013 Yury Sidorov.
 
-  Published at GNU General Public License as Free Software.
- ************************************************************}
+  Transmission Remote GUI is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  Transmission Remote GUI is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with Transmission Remote GUI; if not, write to the Free Software
+  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 
 unit ResTranslator;
 
diff -Naupr transgui-5.18.0/rpc.pas transgui/rpc.pas
--- transgui-5.18.0/rpc.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/rpc.pas	2024-11-20 23:40:05.884955303 +0700
@@ -15,8 +15,19 @@
   You should have received a copy of the GNU General Public License
   along with Transmission Remote GUI; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
-*************************************************************************************}
 
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 unit rpc;
 
 {$mode objfpc}{$H+}
@@ -24,7 +35,8 @@ unit rpc;
 interface
 
 uses
-  Classes, SysUtils, Forms, httpsend, syncobjs, fpjson, jsonparser, ssl_openssl;
+  Classes, SysUtils, Forms, httpsend, syncobjs, fpjson, jsonparser, ssl_openssl,
+  ZStream, jsonscanner;
 
 resourcestring
   sTransmissionAt = 'Transmission%s at %s:%s';
@@ -145,6 +157,27 @@ implementation
 
 uses Main, ssl_openssl_lib, synafpc, blcksock;
 
+function TranslateTableToObjects(reply: TJSONObject) : TJSONObject;
+var
+  array_tor, fields, out_torrents : TJSONArray;
+  object_tor : TJSONObject;
+  i, j : integer;
+begin
+  fields:=reply.Arrays['torrents'].Arrays[0];
+  out_torrents:=TJSONArray.Create;
+  for i:=1 to reply.Arrays['torrents'].Count - 1 do
+  begin
+    array_tor:=reply.Arrays['torrents'].Arrays[i];
+    object_tor:=TJSONObject.Create;
+    for j:=0 to fields.Count - 1 do
+      object_tor.Add(fields.Items[j].AsString, array_tor.Items[j].Clone);
+
+    out_torrents.Add(object_tor);
+  end;
+  Result:=TJSONObject.Create(['torrents', out_torrents]);
+  reply.Free;
+end;
+
 { TRpcThread }
 
 procedure TRpcThread.Execute;
@@ -509,7 +542,7 @@ begin
                                     'maxConnectedPeers', 'nextAnnounceTime', 'dateCreated', 'creator', 'eta', 'peersSendingToUs',
                                     'seeders','peersGettingFromUs','leechers', 'uploadRatio', 'addedDate', 'doneDate',
                                     'activityDate', 'downloadLimited', 'uploadLimited', 'downloadDir', 'id', 'pieces',
-                                    'trackerStats', 'secondsDownloading', 'secondsSeeding', 'magnetLink', 'isPrivate']);
+                                    'trackerStats', 'secondsDownloading', 'secondsSeeding', 'magnetLink', 'isPrivate', 'labels']);
   try
     if args <> nil then begin
       t:=args.Arrays['torrents'];
@@ -619,6 +652,55 @@ begin
   CreateHttp;
 end;
 
+type TGzipDecompressionStream=class(TDecompressionStream)
+public
+  constructor create(Asource:TStream);
+end;
+
+constructor TGzipDecompressionStream.create(Asource:TStream);
+var gzHeader:array[1..10] of byte;
+begin
+  {
+    paszlib is based on a relatively old zlib version that didn't implement
+    reading the gzip header. we "implement" this ourselves by skipping the first
+    10 bytes which is just enough for the data Transmission sends.
+  }
+  inherited create(Asource, True);
+  Asource.Read(gzHeader,sizeof(gzHeader));
+end;
+
+function DecompressGzipContent(source: TStream): TMemoryStream;
+var
+  buf : array[1..16384] of byte;
+  numRead : integer;
+  decomp : TGzipDecompressionStream;
+begin
+  decomp:=TGzipDecompressionStream.create(source);
+  Result:=TMemoryStream.create;
+  repeat
+    numRead:=decomp.read(buf,sizeof(buf));
+    Result.Write(buf,numRead);
+  until numRead < sizeof(buf);
+  Result.Position:=0;
+  decomp.Free;
+end;
+
+function CreateJsonParser(serverResp : THTTPSend): TJSONParser;
+var decompressed : TMemoryStream;
+begin
+  if serverResp.Headers.IndexOf('Content-Encoding: gzip') <> -1 then
+  begin
+    { need to fully decompress as the parser relies on a working Seek() }
+    decompressed:=DecompressGzipContent(serverResp.Document);
+    Result:=TJSONParser.Create(decompressed, [joUTF8]);
+    decompressed.Free;
+  end
+  else
+  begin
+    Result:=TJSONParser.Create(serverResp.Document, [joUTF8]);
+  end;
+end;
+
 function TRpc.SendRequest(req: TJSONObject; ReturnArguments: boolean; ATimeOut: integer): TJSONObject;
 var
   obj: TJSONData;
@@ -646,6 +728,8 @@ begin
       Http.Document.Write(PChar(s)^, Length(s));
       s:='';
       Http.Headers.Clear;
+      Http.Headers.Add('Accept-Encoding: gzip');
+      Http.MimeType:='application/json';
       if XTorrentSession <> '' then
         Http.Headers.Add(XTorrentSession);
       if ATimeOut >= 0 then
@@ -739,7 +823,7 @@ begin
           break;
         end;
         Http.Document.Position:=0;
-        jp:=TJSONParser.Create(Http.Document);
+        jp:=CreateJsonParser(Http);
         HttpLock.Leave;
         locked:=False;
         RequestStartTime:=0;
@@ -800,26 +884,55 @@ begin
   until i >= RetryCnt;
 end;
 
+procedure DeleteIfRpcLessThan(Fields: TStringList; Field: string; RpcVer: integer; NeededRpcVer: integer);
+var
+  idx: integer;
+begin
+  idx := Fields.IndexOf(Field);
+  if (idx <> -1) and (RpcVer < NeededRpcVer) then
+    Fields.Delete(idx);
+end;
+
 function TRpc.RequestInfo(TorrentId: integer; const Fields: array of const; const ExtraFields: array of string): TJSONObject;
 var
   req, args: TJSONObject;
   _fields: TJSONArray;
   i: integer;
+  sl: TStringList;
 begin
   Result:=nil;
   req:=TJSONObject.Create;
+  sl:=TStringList.Create;
   try
     req.Add('method', 'torrent-get');
     args:=TJSONObject.Create;
     if TorrentId <> 0 then
       args.Add('ids', TJSONArray.Create([TorrentId]));
-    _fields:=TJSONArray.Create(Fields);
-    for i:=Low(ExtraFields) to High(ExtraFields) do
-      _fields.Add(ExtraFields[i]);
+    _fields:=TJSONArray.Create;
+    for i:=Low(Fields) to High(Fields) do
+      if (Fields[i].VType=vtAnsiString) then
+         sl.Add(String(Fields[i].VAnsiString));
+    sl.AddStrings(ExtraFields);
+    sl.Sort;
+
+    DeleteIfRpcLessThan(sl, 'labels', FRPCVersion, 16);
+
+    for i:=sl.Count-2 downto 0 do
+      if (sl[i]=sl[i+1]) then
+        sl.Delete(i+1);
+    for i:=0 to sl.Count-1 do
+      _fields.Add(sl[i]);
     args.Add('fields', _fields);
+    if FRPCVersion >= 16 then
+      args.Add('format', 'table');
+
     req.Add('arguments', args);
-    Result:=SendRequest(req);
+    if FRPCVersion >= 16 then
+      Result:=TranslateTableToObjects(SendRequest(req))
+    else
+      Result:=SendRequest(req);
   finally
+    sl.Free;
     req.Free;
   end;
 end;
diff -Naupr transgui-5.18.0/setup/macosx/create_app_new.sh transgui/setup/macosx/create_app_new.sh
--- transgui-5.18.0/setup/macosx/create_app_new.sh	2019-10-12 12:52:07.000000000 +0700
+++ transgui/setup/macosx/create_app_new.sh	2024-11-20 23:40:05.884955303 +0700
@@ -11,7 +11,7 @@ appname="Transmission Remote GUI"
 dmg_dist_file="../../Release/transgui-$prog_ver.dmg"
 dmgfolder=./Release
 appfolder="$dmgfolder/$appname.app"
-lazdir="${1:-/Developer/lazarus/}"
+lazdir="${1:-/Library/Lazarus/}"
 
 if [ -z "${CI-}" ]; then
   ./install_deps.sh
@@ -24,7 +24,7 @@ fi
 mkdir -p ../../Release/
 sed -i.bak "s/'Version %s'/'Version %s Build $build'#13#10'Compiled by: $fpc_ver, Lazarus v$lazarus_ver'/" ../../about.lfm
 
-lazbuild -B ../../transgui.lpi --lazarusdir=/Developer/lazarus/ --compiler=/usr/local/bin/fpc --cpu=x86_64 --widgetset=cocoa
+lazbuild -B ../../transgui.lpi --lazarusdir=/Library/Lazarus/ --compiler=/usr/local/bin/fpc --cpu=x86_64 --widgetset=cocoa
 
 # Building Intel version
 make -j"$(sysctl -n hw.ncpu)" -C ../.. clean CPU_TARGET=x86_64 "$lazdir"
diff -Naupr transgui-5.18.0/setup/macosx/install_deps.sh transgui/setup/macosx/install_deps.sh
--- transgui-5.18.0/setup/macosx/install_deps.sh	2019-10-12 12:52:07.000000000 +0700
+++ transgui/setup/macosx/install_deps.sh	2024-11-20 23:40:05.884955303 +0700
@@ -3,29 +3,23 @@
 set -x
 set -e
 
-lazarus_ver="2.0.4"
-fpc="fpc-3.0.4a.intel-macosx"
-lazarus="lazarus-2.0.4-i686-macosx"
+lazarus_ver="2.0.8"
+fpc="fpc-3.0.4-macos-x86_64-laz-2"
+lazarus="LazarusIDE-2.0.8-macos-x86_64"
 
 if [ -n "${sourceforge_mirror-}" ]; then
   mirror_string="&use_mirror=${sourceforge_mirror}"
 fi
 
 if [ ! -x "$(command -v fpc 2>&1)" ]; then
-  wget "https://downloads.sourceforge.net/project/lazarus/Lazarus%20Mac%20OS%20X%20i386/Lazarus%20${lazarus_ver}/$fpc.dmg?r=&ts=$(date +%s)${mirror_string-}" -O "$fpc.dmg"
-  hdiutil attach -quiet "$fpc.dmg"
-  pkgpath="$(hdiutil attach "$fpc.dmg" | command awk "/Apple_HFS/ { print \$3 }")"
-  sudo installer -pkg "$pkgpath/$fpc.pkg" -target /
-  hdiutil unmount "$pkgpath"
-  rm "$fpc.dmg"
+  wget "https://downloads.sourceforge.net/project/lazarus/Lazarus%20macOS%20x86-64/Lazarus%20${lazarus_ver}/$fpc.pkg?r=&ts=$(date +%s)${mirror_string-}" -O "fpc.pkg"
+  sudo ln -s /usr/local/lib/fpc/3.0.4/ppcx64 /usr/local/bin/ppcx64
+  sudo installer -pkg "fpc.pkg" -target /
+  rm "fpc.pkg"
 fi
 
 if [ ! -x "$(command -v lazbuild 2>&1)" ]; then
-  wget "https://downloads.sourceforge.net/project/lazarus/Lazarus%20Mac%20OS%20X%20i386/Lazarus%20${lazarus_ver}/$lazarus.dmg?r=&ts=$(date +%s)${mirror_string-}" -O "$lazarus.dmg"
-  hdiutil attach -quiet "$lazarus.dmg"
-  pkgpath="$(hdiutil attach "$lazarus.dmg" | command awk "/Apple_HFS/ { print \$3 }")"
-  sudo installer -pkg "$pkgpath/lazarus.pkg" -target /
-  hdiutil unmount "$pkgpath"
-  rm "$lazarus.dmg"
-  lazbuild --build-ide= --compiler=fpc --cpu=x86_64 --widgetset=cocoa
+  wget "https://downloads.sourceforge.net/project/lazarus/Lazarus%20macOS%20x86-64/Lazarus%20${lazarus_ver}/$lazarus.pkg?r=&ts=$(date +%s)${mirror_string-}" -O "lazarus.pkg"
+  sudo installer -pkg "lazarus.pkg" -target /
+  rm "lazarus.pkg"
 fi
diff -Naupr transgui-5.18.0/setup/win/make_setup.bat transgui/setup/win/make_setup.bat
--- transgui-5.18.0/setup/win/make_setup.bat	2019-10-12 12:52:07.000000000 +0700
+++ transgui/setup/win/make_setup.bat	2024-11-20 23:40:05.884955303 +0700
@@ -14,7 +14,7 @@ if "%2" NEQ "" (
     set "ISC=C:\Program Files (x86)\Inno Setup 5"
 )
 
-set path=%LAZARUS_DIR%;%LAZARUS_DIR%\fpc\3.0.4\bin\i386-win32;%path%
+set path=%LAZARUS_DIR%;%LAZARUS_DIR%\fpc\3.2.2\bin\i386-win32;%path%
 
 lazbuild -B ../../transgui.lpi
 if errorlevel 1 goto err
diff -Naupr transgui-5.18.0/setup/win/make_zipdist.bat transgui/setup/win/make_zipdist.bat
--- transgui-5.18.0/setup/win/make_zipdist.bat	2019-10-12 12:52:07.000000000 +0700
+++ transgui/setup/win/make_zipdist.bat	2024-11-20 23:40:05.884955303 +0700
@@ -8,7 +8,7 @@ if "%1" NEQ "" (
     set "LAZARUS_DIR=C:\lazarus"
 )
 
-set path=%LAZARUS_DIR%;%LAZARUS_DIR%\fpc\3.0.4\bin\i386-win32;%path%
+set path=%LAZARUS_DIR%;%LAZARUS_DIR%\fpc\3.2.2\bin\i386-win32;%path%
 
 lazbuild -B ../../transgui.lpi
 if errorlevel 1 goto err
diff -Naupr transgui-5.18.0/setup/win/setup.iss transgui/setup/win/setup.iss
--- transgui-5.18.0/setup/win/setup.iss	2019-10-12 12:52:07.000000000 +0700
+++ transgui/setup/win/setup.iss	2024-11-20 23:40:05.901621971 +0700
@@ -90,14 +90,10 @@ ShowLanguageDialog=yes
 SignTool=signtool sign /d "{#AppName} Setup" /du "{#AppURL}" /f "{#CODECERT}" /v $f
 #endif
 
-[Types]
-Name: "full"; Description: "Full installation"
-Name: "compact"; Description: "Compact installation"
-Name: "custom"; Description: "Custom installation"; Flags: iscustom
-
 [Components]
 Name: "app"; Description: "Main application files"; Types: full compact custom; Flags: fixed
 Name: "lang"; Description: "Language files"; Types: full custom
+Name: "openssl"; Description: "OpenSSL files"; Types: full custom
 
 [Tasks]
 Name: regfileext; Description: "{cm:AssocFileExtension,{#AppName},.torrent}"; Flags: unchecked
@@ -113,8 +109,8 @@ Source: "..\..\README.txt"; DestDir: "{a
 Source: "..\..\history.txt"; DestDir: "{app}"; Flags: ignoreversion; Components: app
 Source: "..\..\lang\transgui.*"; DestDir: "{app}\lang"; Flags: ignoreversion; Components: lang
 ; OpenSSL
-Source: "openssl\libeay32.dll"; DestDir: "{app}"; Components: app
-Source: "openssl\ssleay32.dll"; DestDir: "{app}"; Components: app
+Source: "openssl\libcrypto-1_1.dll"; DestDir: "{app}"; Components: openssl
+Source: "openssl\libssl-1_1.dll"; DestDir: "{app}"; Components: openssl
 
 [Icons]
 Name: "{group}\{#AppName}"; Filename: "{app}\{#AppExeName}"; WorkingDir: {app}
diff -Naupr transgui-5.18.0/setup/win_amd64/make_setup.bat transgui/setup/win_amd64/make_setup.bat
--- transgui-5.18.0/setup/win_amd64/make_setup.bat	2019-10-12 12:52:07.000000000 +0700
+++ transgui/setup/win_amd64/make_setup.bat	2024-11-20 23:40:05.901621971 +0700
@@ -14,7 +14,7 @@ if "%2" NEQ "" (
     set "ISC=C:\Program Files (x86)\Inno Setup 5"
 )
 
-set path=%LAZARUS_DIR%;%LAZARUS_DIR%\fpc\3.0.4\bin\x86_64-win64;%path%
+set path=%LAZARUS_DIR%;%LAZARUS_DIR%\fpc\3.2.2\bin\x86_64-win64;%path%
 
 lazbuild -B ../../transgui.lpi
 if errorlevel 1 goto err
diff -Naupr transgui-5.18.0/setup/win_amd64/make_zipdist.bat transgui/setup/win_amd64/make_zipdist.bat
--- transgui-5.18.0/setup/win_amd64/make_zipdist.bat	2019-10-12 12:52:07.000000000 +0700
+++ transgui/setup/win_amd64/make_zipdist.bat	2024-11-20 23:40:05.901621971 +0700
@@ -8,7 +8,7 @@ if "%1" NEQ "" (
     set "LAZARUS_DIR=C:\lazarus"
 )
 
-set path=%LAZARUS_DIR%;%LAZARUS_DIR%\fpc\3.0.4\bin\x86_64-win64;%path%
+set path=%LAZARUS_DIR%;%LAZARUS_DIR%\fpc\3.2.2\bin\x86_64-win64;%path%
 
 lazbuild -B ../../transgui.lpi
 if errorlevel 1 goto err
diff -Naupr transgui-5.18.0/setup/win_amd64/setup.iss transgui/setup/win_amd64/setup.iss
--- transgui-5.18.0/setup/win_amd64/setup.iss	2019-10-12 12:52:07.000000000 +0700
+++ transgui/setup/win_amd64/setup.iss	2024-11-20 23:40:05.918288637 +0700
@@ -92,14 +92,10 @@ ShowLanguageDialog=yes
 SignTool=signtool sign /d "{#AppName} Setup" /du "{#AppURL}" /f "{#CODECERT}" /v $f
 #endif
 
-[Types]
-Name: "full"; Description: "Full installation"
-Name: "compact"; Description: "Compact installation"
-Name: "custom"; Description: "Custom installation"; Flags: iscustom
-
 [Components]
 Name: "app"; Description: "Main application files"; Types: full compact custom; Flags: fixed
 Name: "lang"; Description: "Language files"; Types: full custom
+Name: "openssl"; Description: "OpenSSL files"; Types: full custom
 
 [Tasks]
 Name: regfileext; Description: "{cm:AssocFileExtension,{#AppName},.torrent}"; Flags: unchecked
@@ -115,8 +111,8 @@ Source: "..\..\README.txt"; DestDir: "{a
 Source: "..\..\history.txt"; DestDir: "{app}"; Flags: ignoreversion; Components: app
 Source: "..\..\lang\transgui.*"; DestDir: "{app}\lang"; Flags: ignoreversion; Components: lang
 ; OpenSSL
-Source: "openssl\libeay32.dll"; DestDir: "{app}"; Components: app
-Source: "openssl\ssleay32.dll"; DestDir: "{app}"; Components: app
+Source: "openssl\libcrypto-1_1-x64.dll"; DestDir: "{app}"; Components: openssl
+Source: "openssl\libssl-1_1-x64.dll"; DestDir: "{app}"; Components: openssl
 
 [Icons]
 Name: "{group}\{#AppName}"; Filename: "{app}\{#AppExeName}"; WorkingDir: {app}
diff -Naupr transgui-5.18.0/snap/local/transgui.desktop transgui/snap/local/transgui.desktop
--- transgui-5.18.0/snap/local/transgui.desktop	2019-10-12 12:52:07.000000000 +0700
+++ transgui/snap/local/transgui.desktop	2024-11-20 23:40:05.918288637 +0700
@@ -3,7 +3,7 @@ Version=1.0
 Name=TransGUI
 GenericName=Transmission Remote GUI
 Comment=Transmission Remote GUI
-Exec=@bindir@/transgui
+Exec=@bindir@/transgui "%U"
 TryExec=@bindir@/transgui
 Icon=transgui
 Terminal=false
diff -Naupr transgui-5.18.0/StringToVK.pas transgui/StringToVK.pas
--- transgui-5.18.0/StringToVK.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/StringToVK.pas	2024-11-20 23:40:05.871621969 +0700
@@ -1,3 +1,33 @@
+{*************************************************************************************
+  This file is part of Transmission Remote GUI.
+  Copyright (c) 2008-2019 by Yury Sidorov and Transmission Remote GUI working group.
+
+  Transmission Remote GUI is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  Transmission Remote GUI is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with Transmission Remote GUI; if not, write to the Free Software
+  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 unit StringToVK;
 
 {$mode objfpc}{$H+}
diff -Naupr transgui-5.18.0/synapse/source/lib/httpsend.pas transgui/synapse/source/lib/httpsend.pas
--- transgui-5.18.0/synapse/source/lib/httpsend.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/synapse/source/lib/httpsend.pas	2024-11-20 23:40:05.921621971 +0700
@@ -289,10 +289,10 @@ begin
   FProxyPass := '';
   FAliveHost := '';
   FAlivePort := '';
-  FProtocol := '1.0';
+  FProtocol := '1.1';
   FKeepAlive := True;
   FStatus100 := False;
-  FUserAgent := 'Mozilla/4.0 (compatible; Synapse)';
+  FUserAgent := 'Mozilla/4.0 (compatible; transmission-remote-gui)';
   FDownloadSize := 0;
   FUploadSize := 0;
   FAddPortNumberToHost := true;
@@ -368,9 +368,12 @@ end;
 
 function THTTPSend.InternalConnect(needssl: Boolean): Boolean;
 begin
+  FSock.PreferIP4 := False; //try to use IPv6
   if FSock.Socket = INVALID_SOCKET then
     Result := InternalDoConnect(needssl)
   else
+    if FSock.LastError <> 0 then
+      FSock.PreferIP4 := True; //fallback to IPv4
     if (FAliveHost <> FTargetHost) or (FAlivePort <> FTargetPort)
       or FSock.CanRead(0) then
       Result := InternalDoConnect(needssl)
diff -Naupr transgui-5.18.0/synapse/source/lib/ssl_openssl_lib.pas transgui/synapse/source/lib/ssl_openssl_lib.pas
--- transgui-5.18.0/synapse/source/lib/ssl_openssl_lib.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/synapse/source/lib/ssl_openssl_lib.pas	2024-11-20 23:40:05.924955304 +0700
@@ -106,8 +106,8 @@ const
   DLLSSLName = 'libssl.so';
   DLLUtilName = 'libcrypto.so';
   {$ELSE}
-  DLLSSLName = 'ssleay32.dll';
-  DLLUtilName = 'libeay32.dll';
+  DLLSSLName = 'libssl-1_1.dll';
+  DLLUtilName = 'libcrypto-1_1.dll';
   {$ENDIF}
 {$ELSE}
 var
@@ -130,9 +130,10 @@ var
      {$ENDIF OS2}
     {$ENDIF}
   {$ELSE}
-  DLLSSLName: string = 'ssleay32.dll';
-  DLLSSLName2: string = 'libssl32.dll';
-  DLLUtilName: string = 'libeay32.dll';
+  DLLSSLName: string = 'libssl-1_1.dll';
+  DLLSSLName2: string = 'libssl-1_1-x64.dll';
+  DLLUtilName: string = 'libcrypto-1_1.dll';
+  DLLUtilName2: string = 'libcrypto-1_1-x64.dll';
   {$ENDIF}
 {$ENDIF}
 
@@ -1883,6 +1884,8 @@ begin
   {$IFDEF MSWINDOWS}
       if (SSLLibHandle = 0) then
         SSLLibHandle := LoadLib(DLLSSLName2);
+      if (SSLUtilHandle = 0) then
+        SSLUtilHandle := LoadLib(DLLUtilName2);
   {$ENDIF}
 {$ENDIF}
       if (SSLLibHandle <> 0) and (SSLUtilHandle <> 0) then
diff -Naupr transgui-5.18.0/torrprops.pas transgui/torrprops.pas
--- transgui-5.18.0/torrprops.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/torrprops.pas	2024-11-20 23:40:05.928288637 +0700
@@ -15,8 +15,19 @@
   You should have received a copy of the GNU General Public License
   along with Transmission Remote GUI; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
-*************************************************************************************}
 
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 unit TorrProps;
 
 {$mode objfpc}{$H+}
diff -Naupr transgui-5.18.0/transgui.lpr transgui/transgui.lpr
--- transgui-5.18.0/transgui.lpr	2019-10-12 12:52:07.000000000 +0700
+++ transgui/transgui.lpr	2024-11-20 23:40:05.928288637 +0700
@@ -11,6 +11,11 @@
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
+  
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
 
   You should have received a copy of the GNU General Public License
   along with Transmission Remote GUI; if not, write to the Free Software
@@ -52,5 +57,10 @@ begin
 
   Application.Initialize;
   Application.CreateForm(TMainForm, MainForm);
+  
+{$ifdef windows}
+  Application.MainFormOnTaskBar:=true;  // make taskbar button follow main form monitor
+{$endif}
+
   Application.Run;
 end.
diff -Naupr transgui-5.18.0/urllistenerosx.pas transgui/urllistenerosx.pas
--- transgui-5.18.0/urllistenerosx.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/urllistenerosx.pas	2024-11-20 23:40:05.928288637 +0700
@@ -1,3 +1,33 @@
+{*************************************************************************************
+  This file is part of Transmission Remote GUI.
+  Copyright (c) 2008-2019 by Yury Sidorov and Transmission Remote GUI working group.
+
+  Transmission Remote GUI is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  Transmission Remote GUI is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with Transmission Remote GUI; if not, write to the Free Software
+  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 unit URLListenerOSX;
 {$mode objfpc}{$H+}
 {$modeswitch objectivec2}
diff -Naupr transgui-5.18.0/utils.pas transgui/utils.pas
--- transgui-5.18.0/utils.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/utils.pas	2024-11-20 23:40:05.928288637 +0700
@@ -15,8 +15,19 @@
   You should have received a copy of the GNU General Public License
   along with Transmission Remote GUI; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
-*************************************************************************************}
 
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 unit utils;
 
 {$mode objfpc}{$H+}
